
{$APPTYPE GUI}{$MODE DELPHI}

program demo49;

uses
  SysUtils,windows,math,gl,glu,GraphOGL,GOGL_Ext;

const
  TexWidth = 64;
  TexHeight = 64;
  TexDepth = 64;
 
//type
  
var 
  i:integer;
  image:array[0..TexDepth-1,0..TexHeight-1,0..TexWidth-1,0..3]of GLubyte;
  tex3d:array[0..2]of GLuint;
  SelTex:integer = 0;
  
   
//{$R *.rc}
//{$R *.res}  
 
 
procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(1,1, 0,1, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 1,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end;   
 
 
procedure QuadTex3d(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,layer,MaxLayer:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(1,1,layer/MaxLayer, 0,1,layer/MaxLayer, x2,y2,z2, x1,y1,z1);
	LineFree(0,0,layer/MaxLayer, 1,0,layer/MaxLayer, x3,y3,z3, x4,y4,z4);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end; 


procedure TestImage;
var
  s,t,r:integer;
begin
  for s:=0 to TexWidth-1 do 
  for t:=0 to TexHeight-1 do 
  for r:=0 to TexDepth-1 do  
  begin
    image[r][t][s][0]:=GLubyte(s*8);
    image[r][t][s][1]:=GLubyte(t*8);
    image[r][t][s][2]:=GLubyte(r*8);
	image[r][t][s][3]:=GLubyte(s*r*t);
  end;
end;


procedure RandomImage;
var
  s,t,r:integer;
begin
  for s:=0 to TexWidth-1 do 
  for t:=0 to TexHeight-1 do 
  for r:=0 to TexDepth-1 do  
  begin
    image[r][t][s][0]:=GLubyte(random(s*8));
    image[r][t][s][1]:=GLubyte(random(t*8));
    image[r][t][s][2]:=GLubyte(random(r*8));
	image[r][t][s][3]:=GLubyte(random(s*r*t));
  end;
end;


procedure CylinderImage;
var
  s,t,r:integer;
  nx,ny,nz,nz_:real;
begin
  for s:=0 to TexWidth-1 do 
  for t:=0 to TexHeight-1 do 
  for r:=0 to TexDepth-1 do  
  begin
  nx:=(s-TexWidth+TexWidth/2)/TexWidth;
  ny:=(t-TexHeight+TexHeight/2)/TexHeight;
  nz:=1-sqrt(nx*nx+ny*ny);
  nz_:=sqrt(nx*nx+ny*ny);
  if nz<0 then nz:=0;  
    image[r][t][s][0]:=GLubyte(Round(nz*TexWidth));
    image[r][t][s][1]:=GLubyte(Round(nz*TexHeight));
    image[r][t][s][2]:=GLubyte(Round(nz*TexDepth));
	image[r][t][s][3]:=GLubyte(Round(nz_*TexDepth));
  end;
end;


procedure LoadTexture3D(img:GOGLProcedure;var texture:glUint);
begin
  img;
  
  glGenTextures(1,@texture);
  glBindTexture(GL_TEXTURE_3D, texture);
  
  glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
  glPixelStorei(GL_UNPACK_ROW_LENGTH, 0);
  glPixelStorei(GL_UNPACK_SKIP_ROWS, 0);
  glPixelStorei(GL_UNPACK_SKIP_PIXELS, 0); 
  glPixelStorei(GL_UNPACK_IMAGE_HEIGHT_EXT, TexDepth); 
  
  glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_WRAP_R, GL_CLAMP);
  
  glTexImage3D(GL_TEXTURE_3D, 0, GL_RGBA, TexWidth,TexHeight,TexDepth, 0, GL_RGBA, GL_UNSIGNED_BYTE, @image); 
  
  glBindTexture(GL_TEXTURE_3D, texture);
end;


procedure DrawTexture3D(x,y,z,size:glfloat);
var 
  i:integer;
begin
  glPushMatrix;  
  glTranslatef(x,y-size,z);
  for i:=0 to TexDepth-1 do 
  QuadTex3d(-size,(size*2-0.1)/TexDepth*i,-size, size,(size*2-0.1)/TexDepth*i,-size, -size,(size*2-0.1)/TexDepth*i,size, size,(size*2-0.1)/TexDepth*i,size, 1,i); 
  glPopMatrix;
end;


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  LoadTexture3D(TestImage,tex3d[0]);
  LoadTexture3D(RandomImage,tex3d[1]);
  LoadTexture3D(CylinderImage,tex3d[2]);
  
end;
begin 

  Load_GL_version_1_2;
  Load_GL_EXT_blend_color;
  Load_GL_EXT_blend_minmax;

  OpenGL_Texture();

end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,0,-30);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(45,1,0,0); 
  
  SetglMouseMove(GL_M0,2);    
  
  PutglPointLight(GL_LIGHT0,0, 0,10,0, 0.1); 

   glDisable(GL_LIGHTING); 
  
  // terreno
  Texture3dOFF;
  glColor3f(0.15,0.15,0.15);
  Quad(-10,0,-10, 10,0,-10, -10,0,10, 10,0,10); 
  glColor3f(1,1,1);   
  Texture3dON;
  

  glEnable(GL_BLEND);
  
  glBlendFunc(GL_CONSTANT_ALPHA_EXT, GL_ONE);
  for i:=0 to TexDepth-1 do
  glBlendColorEXT(1,1,1,1/i); // imposta la trasparenza per le texture 3d
  glBlendEquationEXT(GL_FUNC_ADD_EXT);
  
  // Basi per texture 3d
  glBindTexture(GL_TEXTURE_3D, tex3d[0]); 
  DrawTexture3D(-10,0,0, 4);  
  
  glBindTexture(GL_TEXTURE_3D, tex3d[1]); 
  DrawTexture3D(0,0,0, 4);  
  
  glBindTexture(GL_TEXTURE_3D, tex3d[2]); 
  DrawTexture3D(10,0,0, 4);   
  
  glDisable(GL_BLEND);
  glEnable(GL_LIGHTING);    
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Esempio di texture 3d con il metodo classico opengl', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
